package eu.etaxonomy.taxeditor.prototype2;

import org.eclipse.core.databinding.observable.list.WritableList;
import org.eclipse.core.databinding.observable.set.WritableSet;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.swt.graphics.Image;
import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.osgi.framework.BundleContext;

import eu.etaxonomy.cdm.api.application.CdmApplicationController;
import eu.etaxonomy.cdm.model.agent.Person;
import eu.etaxonomy.cdm.model.name.BotanicalName;
import eu.etaxonomy.cdm.model.name.Rank;
import eu.etaxonomy.cdm.model.taxon.Taxon;


/**
 * The activator class controls the plug-in life cycle
 */
public class Activator extends AbstractUIPlugin {

	/**
	 * The plug-in ID
	 */
	public static final String PLUGIN_ID = "eu.etaxonomy.taxeditor.prototype2.activator";
	/**
	 * The shared instance
	 */	
	private static Activator plugin;
	/**
	 * All CDM services are called via the application controller
	 */
	private CdmApplicationController cdmApp = new CdmApplicationController();
	/**
	 * The dataset of taxa for this session
	 */
	private WritableList observableTaxonTreeList = null;
	/**
	 * Keeps track of which taxa have been edited
	 */
	private WritableList observableRecentNamesList = null;
	public WritableSet observableSynonymSet = null;
	/**
	 * The constructor
	 */
	public Activator() {
//		BotanicalName botName = new BotanicalName(Rank.GENUS());
//		botName.setTitleCache("Hieracium L.");
//		botName.setUninomial("Hieracium");
//		botName.setCombinationAuthorTeam(new Person());
//		botName.getCombinationAuthorTeam().setTitleCache("L.");
//		Taxon genusTaxon = new Taxon();
//		genusTaxon.setName(botName);
//		genusTaxon.setSec(null);
//				
//		BotanicalName botSpecies = new BotanicalName(Rank.SPECIES());
//		botSpecies.setTitleCache("Hieracium asturianum Pau");
//		botSpecies.setUninomial("Hieracium");
//		botSpecies.setSpecificEpithet("asturianum");
//		botSpecies.setCombinationAuthorTeam(new Person());
//		botSpecies.getCombinationAuthorTeam().setTitleCache("Pau");
//		Taxon childTaxon = new Taxon();
//		childTaxon.setName(botSpecies);
//		childTaxon.setSec(null);
//		childTaxon.setTaxonomicParent(genusTaxon, null, null);
//
//		BotanicalName botSpecies2= new BotanicalName(Rank.SPECIES());
//		botSpecies2.setTitleCache("Hieracium wolffii Zahn");
//		botSpecies2.setUninomial("Hieracium");
//		botSpecies2.setSpecificEpithet("wolffii");
//		botSpecies2.setCombinationAuthorTeam(new Person());
//		botSpecies2.getCombinationAuthorTeam().setTitleCache("Zahn");
//		Taxon childTaxon2 = new Taxon();
//		childTaxon2.setName(botSpecies2);
//		childTaxon2.setSec(null);
//		childTaxon2.setTaxonomicParent(genusTaxon, null, null);
//		
//		cdmApp.getTaxonService().saveTaxon(genusTaxon);
//		
//		System.exit(-1);		
	}

	/*
	 * (non-Javadoc)
	 * @see org.eclipse.ui.plugin.AbstractUIPlugin#start(org.osgi.framework.BundleContext)
	 */
	public void start(BundleContext context) throws Exception {
		super.start(context);
		plugin = this;
	}

	/*
	 * (non-Javadoc)
	 * @see org.eclipse.ui.plugin.AbstractUIPlugin#stop(org.osgi.framework.BundleContext)
	 */
	public void stop(BundleContext context) throws Exception {
		plugin = null;
		super.stop(context);
	}

	/**
	 * Returns the shared instance
	 *
	 * @return the shared instance
	 */
	public static Activator getDefault() {
		return plugin;
	}

	/**
	 * Returns an image descriptor for the image file at the given
	 * plug-in relative path
	 *
	 * @param path the path
	 * @return the image descriptor
	 */
	public static ImageDescriptor getImageDescriptor(String path) {
		return imageDescriptorFromPlugin(PLUGIN_ID, path);
	}
	
	
	public Image getImage(String key) {
		return getImageRegistry().get(key);
	}

	public CdmApplicationController getCdmApp() {
		return cdmApp;
	}

	public WritableList getObservableTaxonTreeList() {
		if (observableTaxonTreeList == null) {
			observableTaxonTreeList = new WritableList();
			observableTaxonTreeList.addAll(cdmApp.getTaxonService().getRootTaxa(null));
		}
		return observableTaxonTreeList;
	}
	
	public WritableList getObservableRecentNamesList() {
		if (observableRecentNamesList == null) {
			observableRecentNamesList = new WritableList();
		}
		return observableRecentNamesList;
	}

	public WritableSet getObservableSynonymSet() {
		if (observableSynonymSet == null) {
			observableSynonymSet = new WritableSet();
		}		
		return observableSynonymSet;		
	}
}
