// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.actions.images;

import java.net.URL;

import org.apache.log4j.Logger;
import org.eclipse.core.commands.operations.IUndoableOperation;
import org.eclipse.jface.action.Action;
import org.eclipse.jface.resource.ImageDescriptor;

import eu.etaxonomy.cdm.model.taxon.Taxon;
import eu.etaxonomy.taxeditor.ITaxEditorConstants;
import eu.etaxonomy.taxeditor.TaxEditorPlugin;
import eu.etaxonomy.taxeditor.controller.EditorController;
import eu.etaxonomy.taxeditor.controller.GlobalController;
import eu.etaxonomy.taxeditor.operations.images.AddImageOperation;

/**
 * @author p.ciardelli
 * @created 31.03.2009
 * @version 1.0
 */
public class AddImageAction extends Action {
	private static final Logger logger = Logger
			.getLogger(AddImageAction.class);
	
	private static final String text = "Create new image"; //$NON-NLS-1$
//	private static final ImageDescriptor image = TaxEditorPlugin.getDefault()
//			.getImageDescriptor(ITaxEditorConstants.ADD_CHILD_TAXON_ICON);
	private static final ImageDescriptor image = null;
	
	private Taxon taxon;
	private URL url;
	
	/**
	 * 
	 */
	private AddImageAction() {
		super(text, image);
	}
	
	/**
	 * @param taxon
	 * @param url
	 */
	public AddImageAction(Taxon taxon) {
		this();
		
		this.taxon = taxon;
	}

	public void run() {
		IUndoableOperation operation = new AddImageOperation
				(this.getText(), EditorController.getUndoContext(taxon), taxon);
		
		GlobalController.executeOperation(operation);				
	}
}
