/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.actions.ui;

import org.apache.log4j.Logger;
import org.eclipse.jface.action.Action;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.actions.ActionFactory;

import eu.etaxonomy.cdm.model.taxon.Taxon;
import eu.etaxonomy.taxeditor.ITaxEditorConstants;
import eu.etaxonomy.taxeditor.TaxEditorPlugin;
import eu.etaxonomy.taxeditor.controller.EditorController;

/**
 * Opens a taxon editor for an existing taxon.
 * 
 * FIXME this action is broken and actually throws lots of hibernate exceptions
 * 
 * @author p.ciardelli
 * @created 02.06.2008
 * @version 1.0
 * @deprecated
 */
public class OpenTaxonEditorAction extends Action implements ActionFactory.IWorkbenchAction {
	private static final Logger logger = Logger
			.getLogger(OpenTaxonEditorAction.class);

	private static String editTaxonText = "Edit taxon";
	private static String newTaxonText = "Add new taxon";
	private ImageDescriptor image = TaxEditorPlugin.getDefault()
			.getImageDescriptor(ITaxEditorConstants.OPEN_TAXON_ICON);

	private IWorkbenchWindow window;
	
	private Taxon taxon;
	public static final String ID = "eu.etaxonomy.taxeditor.actions.opennameeditoraction"; //$NON-NLS-1$
	
	@Deprecated
	public OpenTaxonEditorAction(Taxon taxon) {
		this();
		
		this.taxon = taxon;
		if (taxon != null) {
			setText(editTaxonText);
		}
	}

	@Deprecated
	public OpenTaxonEditorAction() {
		super(newTaxonText);
		setImageDescriptor(image);
		setId(ID);
	}
	
	@Override
	@Deprecated
	public void run() {
		
    	EditorController.open(taxon);
		
		// For clients who re-use the same instance of this class, 
		//	taxon is re-initalized to ensure a new Taxon is opened every time
		taxon = null;
	}

	public void dispose() {
	}
}