// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.editor.description;

import org.apache.log4j.Logger;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.forms.IManagedForm;
import org.eclipse.ui.views.properties.IPropertySource;

import eu.etaxonomy.cdm.model.common.Language;
import eu.etaxonomy.cdm.model.description.CommonTaxonName;
import eu.etaxonomy.taxeditor.model.LanguageUtil;
import eu.etaxonomy.taxeditor.propertysheet.description.CommonNamePropertySource;

/**
 * @author p.ciardelli
 * @created 02.04.2009
 * @version 1.0
 */
public class CommonNameComposite extends DescriptionElementComposite {
	private static final Logger logger = Logger
			.getLogger(CommonNameComposite.class);
	
	/**
	 * @param groupComposite
	 * @param form
	 * @param element
	 */
	public CommonNameComposite(Composite parent, IManagedForm form,
			CommonTaxonName element) {
		super(parent, form, element);
		
		setLanguageInfo();
	}
	
	/**
	 * 
	 */
	private void setLanguageInfo() {
		
		Language language = ((CommonTaxonName) element).getLanguage();
		if (language != null) {
			setNonEditableInfo(LanguageUtil.getDescription(language));
		} else {
			setNonEditableInfo("No language");
		}		
	}

	public IPropertySource getPropertySource() {
		return new CommonNamePropertySource((CommonTaxonName) getElement());
	}
}