// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.editor.images;

import java.net.URL;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

import org.apache.log4j.Logger;
import org.eclipse.swt.graphics.Image;

import eu.etaxonomy.cdm.model.taxon.Taxon;
import eu.etaxonomy.taxeditor.TaxEditorPlugin;

/**
 * @author p.ciardelli
 * @created 31.03.2009
 * @version 1.0
 */
public class ImagesController {
	private static final Logger logger = Logger
			.getLogger(ImagesController.class);
	
	static Map<Taxon, Set<URL>> taxonImageUrls = new HashMap<Taxon, Set<URL>>();
	static Map<URL, Image> urlImages = new HashMap<URL, Image>();
	
	public static Set<URL> getTaxonImageUrls(Taxon taxon) {
		Set<URL> imageUrls = taxonImageUrls.get(taxon); 
		if (imageUrls == null) {
			imageUrls = new HashSet<URL>();
			taxonImageUrls.put(taxon, imageUrls);
		}
		return imageUrls;
	}

	/**
	 * @param taxon
	 * @param url
	 */
	public static void addTaxonImageUrl(Taxon taxon, URL url) {
		getTaxonImageUrls(taxon).add(url);
	}

	/**
	 * @param taxon
	 * @param url
	 */
	public static void removeTaxonImageUrl(Taxon taxon, URL url) {
		getTaxonImageUrls(taxon).remove(url);
	}

	/**
	 * @param url
	 * @return
	 */
	public static Image getImage(URL url) {
		return TaxEditorPlugin.getDefault().getImage(url);
	}
}