/**
 * 
 */
package eu.etaxonomy.taxeditor.handlers;

import org.apache.log4j.Logger;
import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.commands.IHandler;
import org.eclipse.core.commands.common.NotDefinedException;
import org.eclipse.core.commands.operations.IUndoableOperation;

import eu.etaxonomy.cdm.model.taxon.Taxon;
import eu.etaxonomy.taxeditor.controller.EditorController;
import eu.etaxonomy.taxeditor.controller.GlobalController;
import eu.etaxonomy.taxeditor.operations.name.CreateMisappliedNameOperation;

/**
 * @author nho
 *
 */
public class CreateMisappliedNameHandler extends AbstractHandler implements IHandler {
	private static final Logger logger = Logger
			.getLogger(CreateMisappliedNameHandler.class);
	
	/* (non-Javadoc)
	 * @see org.eclipse.core.commands.IHandler#execute(org.eclipse.core.commands.ExecutionEvent)
	 */
	public Object execute(ExecutionEvent event) throws ExecutionException {
		Taxon taxon = EditorController.getActiveEditor().getTaxon();
		
		IUndoableOperation operation;
		try {
			operation = new CreateMisappliedNameOperation(event.getCommand().getName(), 
						EditorController.getUndoContext(taxon), taxon);
			GlobalController.executeOperation(operation);
		} catch (NotDefinedException e) {
			logger.warn("Command name not set");
		}
		
		return null;
	}

}
