// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.model;

import java.util.List;

import eu.etaxonomy.cdm.model.description.AbsenceTerm;
import eu.etaxonomy.cdm.model.description.PresenceAbsenceTermBase;
import eu.etaxonomy.cdm.model.description.PresenceTerm;
import eu.etaxonomy.cdm.model.location.NamedArea;

/**
 * @author p.ciardelli
 * @created 03.04.2009
 * @version 1.0
 */
public interface IDistributionInfoProvider {
	
	/**
	 * i.e. TDWG, ISO
	 * 
	 * @return
	 */
	List<Object> getVocabularyTypes();
	
	List<NamedArea> getVocabularyTopLevelAreas(Object vocabularyType);
	
	List<NamedArea> getVocabularyNextLevelAreas(NamedArea namedArea);
		
	List<PresenceTerm> getPresenceTerms();
	
	List<AbsenceTerm> getAbsenceTerms();

	String getVocabularyTypeLabel(Object vocabularyType);

	String getPresenceAbsenceTermLabel(PresenceAbsenceTermBase<?> term);
	
	NamedArea getNamedAreaParent(NamedArea namedArea);
	
	List<NamedArea> getNamedAreaChildren(NamedArea namedArea);
}