/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.navigation;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;

import org.apache.log4j.Logger;

import eu.etaxonomy.cdm.model.common.IdentifiableEntity;

/**
 * @author p.ciardelli
 * @created 19.01.2009
 * @version 1.0
 */
public class SearchResult implements Collection<IdentifiableEntity> {
	private static final Logger logger = Logger.getLogger(SearchResult.class);

	List<IdentifiableEntity> searchResult = new ArrayList<IdentifiableEntity>();
	
	
	public boolean add(IdentifiableEntity e) {
		return searchResult.add(e);
	}

	
	public boolean addAll(Collection<? extends IdentifiableEntity> c) {
		return searchResult.addAll(c);
	}

	
	public void clear() {
		searchResult.clear();
	}

	
	public boolean contains(Object o) {
		return searchResult.contains(o);
	}

	
	public boolean containsAll(Collection<?> c) {
		return searchResult.containsAll(c);
	}

	
	public boolean isEmpty() {
		return searchResult.isEmpty();
	}

	
	public Iterator<IdentifiableEntity> iterator() {
		return searchResult.iterator();
	}

	
	public boolean remove(Object o) {
		return searchResult.remove(o);
	}

	
	public boolean removeAll(Collection<?> c) {
		return searchResult.removeAll(c);
	}

	
	public boolean retainAll(Collection<?> c) {
		return searchResult.retainAll(c);
	}

	
	public int size() {
		return searchResult.size();
	}

	
	public Object[] toArray() {
		return searchResult.toArray();
	}

	
	public <T> T[] toArray(T[] a) {
		return searchResult.toArray(a);
	}

	String searchString; 
	
	public String getSearchString() {
		return searchString;
	}
	
	public void setSearchString(String searchString) {
		this.searchString = searchString;
	}
}
