// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.bulkeditor;

import java.util.HashMap;
import java.util.Map;

import eu.etaxonomy.cdm.model.name.Rank;
import eu.etaxonomy.cdm.model.name.TaxonNameBase;
import eu.etaxonomy.taxeditor.annotatedlineeditor.IEntityCreator;
import eu.etaxonomy.taxeditor.preference.PreferencesUtil;

/**
 * @author p.ciardelli
 * @created 07.07.2009
 * @version 1.0
 */
public class NameCreator implements IEntityCreator<TaxonNameBase> {

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.bulkeditor.IEntityCreator#createEntity(java.lang.String)
	 */
	public TaxonNameBase createEntity(String text) {
		TaxonNameBase name = PreferencesUtil.getPreferredNomenclaturalCode().getNewTaxonNameInstance(null);
		name.setTitleCache(text);
		return name;
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.annotatedlineeditor.IEntityCreator#createEntity(java.lang.Class, java.lang.String)
	 */
	public TaxonNameBase createEntity(Object key, String text) {
		TaxonNameBase name = PreferencesUtil.getPreferredNomenclaturalCode().getNewTaxonNameInstance((Rank) key);
		name.setTitleCache(text);
		return name;
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.annotatedlineeditor.IEntityCreator#getClassLabelPairs()
	 */
	public Map<Object, String> getKeyLabelPairs() {
		Map<Object, String> result = new HashMap<Object, String>();
		for (Rank rank : PreferencesUtil.getPreferredRanks()) {
			result.put(rank, rank.getLabel());
		}
		return result;
	}
}
