// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.bulkeditor.input;

import java.beans.PropertyChangeSupport;

import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.ui.IEditorInput;
import org.eclipse.ui.IPersistableElement;

import eu.etaxonomy.taxeditor.bulkeditor.IBulkEditorQuery;

/**
 * @author p.ciardelli
 * @created 25.06.2009
 * @version 1.0
 * @param <T>
 */
abstract public class BulkEditorInput extends PropertyChangeSupport implements IEditorInput {

	/**
	 * @param sourceBean
	 */
	public BulkEditorInput(Object sourceBean) {
		super(sourceBean);
	}
	
	public static final String QUERY_CHANGED = "query_changed";
	
	static public BulkEditorInput NewInstance(String inputType) {
				
		if (ReferenceEditorInput.getID().equals(inputType)) {
			return new ReferenceEditorInput();
		}

		if (NameEditorInput.getID().equals(inputType)) {
			return new NameEditorInput();
		}

		if (AgentEditorInput.getID().equals(inputType)) {
			return new AgentEditorInput();
		}
		
		return null;
	}

	private IBulkEditorQuery query;
			
	/* (non-Javadoc)
	 * @see org.eclipse.ui.IEditorInput#exists()
	 */
	public boolean exists() {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see org.eclipse.ui.IEditorInput#getImageDescriptor()
	 */
	public ImageDescriptor getImageDescriptor() {
		// TODO Auto-generated method stub
		return null;
	}

	/* (non-Javadoc)
	 * @see org.eclipse.ui.IEditorInput#getPersistable()
	 */
	public IPersistableElement getPersistable() {
		return null;
	}

	/* (non-Javadoc)
	 * @see org.eclipse.core.runtime.IAdaptable#getAdapter(java.lang.Class)
	 */
	@SuppressWarnings("unchecked")
	public Object getAdapter(Class adapter) {
		return null;
	}

	/**
	 * @param bulkEditorQuery
	 */
	public void setQuery(IBulkEditorQuery bulkEditorQuery) {
				
		this.query = bulkEditorQuery;
		
		if (query != null) {
			firePropertyChange(QUERY_CHANGED, null, null);
		}
	}
	
	public IBulkEditorQuery getQuery() {
		return query;
	}
	
	abstract public boolean isMergingEnabled();
}