/**
 * 
 */
package eu.etaxonomy.taxeditor.editor.descriptiontree;

import org.apache.log4j.Logger;

import eu.etaxonomy.cdm.model.description.Feature;
import eu.etaxonomy.cdm.model.description.TaxonDescription;

/**
 * Helper class used to group a description's elements by feature.
 * 
 * @author p.ciardelli
 *
 */
public class TaxonDescriptionFeature {
	private static final Logger logger = Logger.getLogger(TaxonDescriptionFeature.class);
	
	private TaxonDescription description;
	private Feature feature;

	public TaxonDescriptionFeature(TaxonDescription description, Feature feature) {
		this.description = description;
		this.feature = feature;
	}
	
	/**
	 * @return the description
	 */
	public TaxonDescription getDescription() {
		return description;
	}

	/**
	 * @return the feature
	 */
	public Feature getFeature() {
		return feature;
	}
}