// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.dialogs.filteredSelection;

import java.util.UUID;

import org.apache.log4j.Logger;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Shell;

import eu.etaxonomy.cdm.model.agent.TeamOrPersonBase;
import eu.etaxonomy.taxeditor.store.CdmStore;

/**
 * @author n.hoffmann
 * @created Sep 24, 2009
 * @version 1.0
 */
public class FilteredTeamOrPersonBaseSelectionDialog extends
		AbstractFilteredCdmResourceSelectionDialog<TeamOrPersonBase> {
	private static final Logger logger = Logger
		.getLogger(FilteredTeamOrPersonBaseSelectionDialog.class);
	
	public TeamOrPersonBase selectTeamOrPersonBase(Shell shell, TeamOrPersonBase teamOrPersonBase){
		FilteredTeamOrPersonBaseSelectionDialog dialog = new FilteredTeamOrPersonBaseSelectionDialog(shell,
				"Choose Team or Person", false, null, teamOrPersonBase);
		return getSelectionFromDialog(dialog);
	}
	
	/**
	 * @param shell
	 * @param title
	 * @param multi
	 * @param settings
	 * @param cdmObject
	 */
	protected FilteredTeamOrPersonBaseSelectionDialog(Shell shell,
			String title, boolean multi, String settings,
			TeamOrPersonBase cdmObject) {
		super(shell, title, multi, settings, cdmObject);
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.dialogs.filteredSelection.AbstractFilteredCdmResourceSelectionDialog#getPersistentObject(java.util.UUID)
	 */
	@Override
	protected TeamOrPersonBase getPersistentObject(UUID uuid) {
		return (TeamOrPersonBase) CdmStore.getAgentService().getAgentByUuid(uuid);
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.dialogs.filteredSelection.AbstractFilteredCdmResourceSelectionDialog#initModel()
	 */
	@Override
	protected void initModel() {
		model = CdmStore.getAgentService().getTeamOrPersonBaseUuidAndNomenclaturalTitle();
	}

	/* (non-Javadoc)
	 * @see org.eclipse.ui.dialogs.FilteredItemsSelectionDialog#createExtendedContentArea(org.eclipse.swt.widgets.Composite)
	 */
	@Override
	protected Control createExtendedContentArea(Composite parent) {
		return null;
	}
}
