// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.io.wizard;

import java.io.File;

import org.apache.log4j.Logger;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.IWorkbench;

import eu.etaxonomy.cdm.io.jaxb.JaxbExportConfigurator;
import eu.etaxonomy.taxeditor.store.CdmStore;

/**
 * @author n.hoffmann
 * @created 15.06.2009
 * @version 1.0
 */
public class JaxbExportWizard extends AbstractExportWizard<JaxbExportConfigurator> {
	private static final Logger logger = Logger
			.getLogger(JaxbExportWizard.class);

	private ExportToFileDestinationWizardPage page;

	private JaxbExportConfigurator configurator;

	/* (non-Javadoc)
	 * @see org.eclipse.ui.IWorkbenchWizard#init(org.eclipse.ui.IWorkbench, org.eclipse.jface.viewers.IStructuredSelection)
	 */
	public void init(IWorkbench workbench, IStructuredSelection selection) {
		this.setWindowTitle("JAXB Export");
		this.configurator = JaxbExportConfigurator.NewInstance(null, null);
	}
	
	/* (non-Javadoc)
	 * @see org.eclipse.jface.wizard.Wizard#performFinish()
	 */
	@Override
	public boolean performFinish() {
		
		String urlString = page.getFolderText() + File.pathSeparator + page.getExportFileName();
		
		configurator.setDestination(urlString);
		configurator.setCdmAppController(CdmStore.getApplicationControllerWillBeObsolete());
		
		return doExport(configurator);
	}

	/* (non-Javadoc)
	 * @see org.eclipse.jface.wizard.Wizard#addPages()
	 */
	@Override
	public void addPages() {
		super.addPages();
				
		page = ExportToFileDestinationWizardPage.Jaxb();
		addPage(page);
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.io.AbstractExportWizard#getConfigurator()
	 */
	@Override
	public JaxbExportConfigurator getConfigurator() {
		return configurator;
	}
	

}
